#
# spec file for package ghc-bootstrap-helpers
#
# Copyright (c) 2023 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%define         alex_ver 3.5.1.0
%define         happy_ver 1.20.1.1

Name:           ghc-bootstrap-helpers
Version:        1.4
Release:        1.4
Summary:        Dependencies to build ghc
License:        BSD-2-Clause AND BSD-3-Clause
URL:            https://build.opensuse.org/project/show/devel:languages:haskell
Source:         https://hackage.haskell.org/package/alex-%{alex_ver}/alex-%{alex_ver}.tar.gz
Source1:        https://hackage.haskell.org/package/happy-%{happy_ver}/happy-%{happy_ver}.tar.gz
BuildRequires:  ghc-bootstrap
ExcludeArch:    %{ix86}
# This package is not meant to be used outside OBS
Requires:       this-is-only-for-build-envs

Conflicts:      alex
Conflicts:      happy

%description
Prebuild alex and happy for bootstrapping the proper ghc build.
Don't use outside of GHC bootstrapping!

%prep
%setup -q -c -a0 -a1

%build
pushd alex-%{alex_ver}
/opt/bin/ghc Setup.hs -o cabal
./cabal configure --prefix=%{_prefix}
./cabal build
popd

pushd happy-%{happy_ver}
/opt/bin/ghc Setup.hs -o cabal
./cabal configure --prefix=%{_prefix}
./cabal build
popd

%install
pushd alex-%{alex_ver}
./cabal copy --destdir=%{buildroot}
popd

pushd happy-%{happy_ver}
./cabal copy --destdir=%{buildroot}
popd

%files
%{_bindir}/alex
%{_bindir}/happy
%{_datadir}/*ghc*
%{_datadir}/doc/*ghc*

%changelog
* Wed Mar 20 2024 Ondřej Súkup <mimi.vx@gmail.com>
- update alex to 3.5.1.0
- upadate happy to 1.20.1.1
* Wed Aug  2 2023 Andreas Schwab <schwab@suse.de>
- Reduce memory constraints for riscv64
* Thu May 25 2023 Andreas Schwab <schwab@suse.de>
- Adjust constraints for riscv64
* Mon Jan 30 2023 Peter Simons <psimons@suse.com>
- Update alex to version 3.2.7.1 for bootstrapping ghc-9.4.4.
* Thu Dec 17 2020 Ondřej Súkup <mimi.vx@gmail.com>
- disable %%{ix86} build
* Tue Sep  8 2020 Ondřej Súkup <mimi.vx@gmail.com>
- update to 1.1 - update happy to 1.9.20
* Tue Jun  2 2020 Ondřej Súkup <mimi.vx@gmail.com>
- add constraints for memory on riscv64
* Sat Jan 18 2020 Peter Trommler <ptrommler@icloud.com>
- improve packaging and avoid rpmlint warning
* Fri Jan 17 2020 Peter Trommler <ptrommler@icloud.com>
- build happy and alex form source using ghc-bootstrap
* Sun Dec 29 2019 Ondřej Súkup <mimi.vx@gmail.com>
- initial commit
